Available in🇮🇳 India
Follow the steps to integrate Custom Checkout in your site:
1.1 Create an Order in Server.
1.2 Fetch Payment Methods.
1.3 Invoke Checkout and Pass Order Id and Other Options to it.
1.3.1 Include JavaScript code in your Webpage.
1.3.2 Instantiate Custom Checkout.
1.3.3 Submit Payment Details.
1.4 Store Fields in Your Server.
1.5 Verify Payment Signature.
1.6 Verify Payment Status.
1.1 Create an Order in Server
Order is an important step in the payment process.- An order should be created for every payment.
- You can create an order using the Orders API. It is a server-side API call. Know how to authenticate Orders API.
- The order_id received in the response should be passed to the checkout. This ties the Order with the payment and secures the request from being tampered.
API Sample Code
The following is a sample API request and response for creating an order:Request Parameters
Here is the list of parameters and their description for creating an order:amount mandatory
: integer Payment amount in the smallest currency sub-unit. For example, if the amount to be charged is ₹299, then pass 29900 in this field. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.
currency mandatory
: string Currency code for the currency in which you want to accept the payment. For example, INR. Refer to the supported currencies for a list of supported international currencies.
Handy TipsRazorpay has added support for zero decimal currencies, such as JPY, and three decimal currencies, such as KWD, BHD, and OMR, allowing businesses to accept international payments in these currencies. Know more about Currency Conversion (May 2024).
amount mandatory
: integer Payment amount in the smallest currency sub-unit. For example, if the amount to be charged is ₹299, then pass 29900 in this field.
currency mandatory
: string Currency code for the currency in which you want to accept the payment.
receipt optional
: string Your receipt id for this order should be passed here. Maximum length is 40 characters.
notes optional
: json object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.
partial_payment optional
: boolean Indicates whether the customer can make a partial payment. Possible values:
true: The customer can make partial payments.false(default): The customer cannot make partial payments.
id mandatory
: string Unique identifier of the customer. For example, cust_1Aa00000000004.
Know more about Orders API.
Error Response Parameters
The error response parameters are available in the API Reference Guide.1.2 Fetch Payment Methods
When creating a custom checkout form, display only the activated methods to the customer. Use the below methods to fetch all payments methods available to you:1.3 Invoke Checkout and Pass Order Id and Other Options to it
1.3.1 Include JavaScript code in your Webpage
Include the following script, preferably in the<head> section of your page:
Index HTML
Handy Tips
- Include the script from
https://checkout.razorpay.com/v1/razorpay.jsinstead of serving a copy from your server. This allows the library’s new updates and bug fixes to fit your application automatically. - We always maintain backward compatibility with our code.
1.3.2 Instantiate Custom Checkout
- Single Instance on a Page:
Invoke a Single Instance
- Multiple Instances on Same Page: If you need multiple Razorpay instances on the same page, you can globally set some of the options:
Invoke Multiple Instances
Customer Fee Bearer (CFB) RequirementsFor card payments with CFB enabled, set
redirect: true and include callback_url during Razorpay instantiation.Checkout Options
While building a custom UI for accepting payments from your customers, you should be familiar with the fields supported in therazorpay.js script.
key mandatory
: string API Key ID generated from Dashboard → Account & Settings → API Keys.
amount mandatory
: integer Payment amount in the smallest currency sub-unit. For example, if the amount to be charged is ₹299, then pass 29900 in this field. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.999, pass the value as 295999. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.
currency mandatory
: string The currency in which the payment should be made by the customer. For example, INR. See the list of supported currencies.
Handy TipsRazorpay has added support for zero decimal currencies, such as JPY, and three decimal currencies, such as KWD, BHD, and OMR, allowing businesses to accept international payments in these currencies. Know more about Currency Conversion (April 2023).
description optional
: string Description of the product shown in the Checkout form. It must start with an alphanumeric character.
image optional
: string Link to an image (usually your business logo) shown in the Checkout form. Can also be a base64 string, if loading the image from a network is not desirable.
order_id mandatory
: string Order ID generated via the Orders API.
notes optional
: object Set of key-value pairs that can be used to store additional information about the payment. It can hold a maximum of 15 key-value pairs, each 256 characters long (maximum).
method mandatory
: string The payment method used by the customer on Checkout. Possible values:
card(default)upi(default)netbanking(default)wallet(default)emi(default)cardless_emi(requires approval)paylater(requires approval)emandate(requires approval)
card mandatory if method=card/emi
: object The details of the card that should be entered while making the payment.
number
: integer Unformatted card number.
name
: string The name of the cardholder.
expiry_month
: integer Expiry month for card in MM format.
expiry_year
: integer Expiry year for card in YY format.
cvv
: integer CVV printed on the back of the card.
Handy Tips
- CVV is not required by default for tokenised cards across all networks.
- CVV is optional for tokenised card payments. Do not pass dummy CVV values.
- To implement this change, skip passing the
cvvparameter entirely, or pass anullor empty value in the CVV field. - We recommend removing the CVV field from your checkout UI/UX for tokenised cards.
- If CVV is still collected for tokenised cards and the customer enters a CVV, pass the entered CVV value to Razorpay.
emi_duration
: integer Defines the number of months in the EMI plan.
bank_account mandatory if method=emandate
: The details of the bank account that should be passed in the request. These details include bank account number, IFSC code and the name of the customer associated with the bank account.
account_number
: string Bank account number used to initiate the payment.
ifsc
: string IFSC of the bank used to initiate the payment.
name
: string Name associated with the bank account used to initiate the payment.
bank mandatory if method=netbanking
: string Bank code. List of available banks enabled for your account can be fetched via methods.
wallet mandatory if method=wallet
: string Wallet code for the wallet used for the payment. Possible values:
payzapp(default)olamoney(requires approval)phonepe(requires approval)airtelmoney(requires approval)mobikwik(requires approval)jiomoney(requires approval)amazonpay(requires approval)paypal(requires approval)phonepeswitch(requires approval)
provider mandatory if method=cardless_emi/paylater
: string Name of the cardless EMI provider partnered with Razorpay.
Available options for Cardless EMI (requires approval):
hdfcicicidfbkkbkzestmoneyearlysalarywalnut369
lazypaypaypal
vpa mandatory if method=upi
: string UPI ID used for making the payment on the UPI app.
callback_url optional
: string The URL to which the customer must be redirected upon completion of payment. The URL must accept incoming POST requests. The callback URL will have razorpay_payment_id, razorpay_order_id and razorpay_signature as the request parameters for a successful payment.
redirect conditionally mandatory
: boolean Determines whether customer should be redirected to the URL mentioned in the
callback_url parameter. This is mandatory if callback_url parameter is used. Possible values:
true: Customer will be redirected to thecallback_url.false: Customer will not be redirected to thecallback_url
1.3.3 Submit Payment Details
After creating an order and obtaining the customer’s payment details, send the information to Razorpay to complete the payment. The data that needs to be submitted depends on the customer’s payment method. You can do this by invokingcreatePayment method.Know more about sample codes for various payment methods.
Handy Tips
- Handler Function
When you use the handler function, the response object of the successful payment (razorpay_payment_id,razorpay_order_idandrazorpay_signature) is submitted to the Checkout Form. You need to collect these and send them to your server. - Callback URL
When you use a callback URL, Razorpay makes a post call to the callback URL, with therazorpay_payment_id,razorpay_order_idandrazorpay_signaturein the response object of the successful payment (razorpay_payment_idandrazorpay_order_id).
1.4 Store Fields in Your Server
A successful payment returns the following fields to the Checkout form.Success Callback
Success Callback
- You need to store these fields in your server.
- You can confirm the authenticity of these details by verifying the signature in the next step.
razorpay_payment_id
: string Unique identifier for the payment returned by Checkout only for successful payments.razorpay_order_id
: string Unique identifier for the order returned by Checkout.razorpay_signature
: string Signature returned by the Checkout. This is used to verify the payment.Failure Response
Failure Response
1.5 Verify Payment Signature
This is a mandatory step to confirm the authenticity of the details returned to the Checkout form for successful payments.To verify the `razorpay_signature` returned to you by the Checkout form:
To verify the `razorpay_signature` returned to you by the Checkout form:
-
Create a signature in your server using the following attributes:
order_id: Retrieve theorder_idfrom your server. Do not use therazorpay_order_idreturned by Checkout.razorpay_payment_id: Returned by Checkout.key_secret: Available in your server. Thekey_secretthat was generated from the Dashboard.
-
Use the SHA256 algorithm, the
razorpay_payment_idand theorder_idto construct a HMAC hex digest as shown below:
HMAC Hex Digest
- If the signature you generate on your server matches the
razorpay_signaturereturned to you by the Checkout form, the payment received is from an authentic source.
Generate Signature on Your Server
Generate Signature on Your Server
Given below is the sample code for payment signature verification:
Post Signature Verification
Post Signature Verification
After you have completed the integration, you can set up webhooks, make test payments, replace the test key with the live key and integrate with other APIs.
1.6 Verify Payment Status
Handy TipsOn the Razorpay Dashboard, ensure that the payment status is
captured. Refer to the payment capture settings page to know how to capture payments automatically.You can track the payment status in three ways:
You can track the payment status in three ways:
- Verify Status from Dashboard
- Subscribe to Webhook Events
- Poll APIs
To verify the payment status from the Razorpay Dashboard:
- Log in to the Razorpay Dashboard and navigate to Transactions → Payments.
- Check if a Payment Id has been generated and note the status. In case of a successful payment, the status is marked as Captured.
